
bridge =  (require "./Bridge.coffee").bridge
utils =  (require "./Utils.coffee")


{app} = (require "./App.coffee")

{TableComponent} = require "./TableComponent.coffee"



Framer.Defaults.Layer =
	backgroundColor: ""

Colors =
	background: "#151619"
	text: "#6A7281"
	textHighlight: "#FFFFFF"
	textInvisible: "#3B4250"
	indent: "#2A2D33"

# Sizes = {}
# Sizes.base = 8
# Sizes.rowHeight = 36
# Sizes.indent = Sizes.base
# Sizes.indentWidth = 1
# Sizes.indentHeight = Sizes.base * 2

Sizes = {}
Sizes.base = 8
Sizes.rowHeight = 32
Sizes.indent = 12
Sizes.indentWidth = 1
Sizes.indentHeight = Sizes.rowHeight

grey = (n) -> "rgb(#{n}, #{n}, #{n})"

scroll = new Layer
	x: 180
	width: 180
	height: window.innerHeight

Screen.on "resize", ->
	scroll.height = window.innerHeight

scroll.scroll = true
scroll.scrollHorizontal = false
scroll.backgroundColor = Colors.background
scroll.style.borderLeft = "1px solid #{Colors.border}"
scroll.style.borderLeft = "1px solid #000000"

table = new TableComponent
	width: scroll.width
	height: window.innerHeight
	superView: scroll
table.backgroundColor = ""


table.data = []


table.totalRows = -> @data.length
table.heightForRow = (index) -> Sizes.rowHeight
table.marginForRow = (index) -> 0
table.createRow = ->
	row = new Layer
		height: table.heightForRow()
	row.style =
		borderBottom: "1px solid #{Colors.border}"
	row.textLayer = new Layer
		x: Sizes.indent
		width: row.width - Sizes.indent
		height: table.heightForRow()
		superLayer: row
		backgroundColor: Colors.background
	row.textLayer.style =
		font: "11px HelveticaNeue-Medium"
		color: Colors.text
		lineHeight: "#{table.heightForRow()}px"
		letterSpacing: "0.4px"
		textShadow: "0px 1px 1px rgba(0,0,0,0.50)"
		"-webkit-font-smoothing": "antialiased"
		"-webkit-user-select": "none"
	row.on Events.MouseOver, @onRowEnter
	row.on Events.MouseOut, @onMouseOut
	row.on Events.Click, @onClick
	row

table.updateRow = (index, row) ->
	row.data = @data[index]
	row.textLayer.html = "#{row.data.name}"

	if @isRowSelected("hover", row)
		row.textLayer.style.color = app.config.colors.textHighlight
	else
		row.textLayer.style.color = Colors.text

	if @isRowSelected("selection", row)
		row.backgroundColor = row.textLayer.backgroundColor = app.config.colors.tableSelectionBackground
	else
		row.backgroundColor = row.textLayer.backgroundColor = app.config.colors.background

table.onRowEnter = (event, row) =>
	table.setSelectedRows("hover", [row])

table.onMouseOut = (event, row) ->
	table.setSelectedRows("hover", [])

table.onMouseOut = (event, row) ->
	table.unHighlight()

table.unHighlight = ->
	table._highlightedRow?.textLayer.style =
		color: textColor(table._highlightedRow.data)

table.onClick = (event, row) ->
	table.setSelectedRows("selection", [row])


app.views.stateTable = table

table.reload = ->

	data = [{name:"Current", values:{}}]

	for item in app.views.layerTable.data
		if item.id is app.state.selectedLayerId
			for k, v of item.states
				data.push({name:k, values:v})
			break

	table.data = data

	# console.log "selected", table.getSelectedRows()
	# console.log "yo", table.rowForIndex(0)
	# console.log "yo", _.map([0], table.rowForIndex)

	# if table.getSelectedRows().length == 0
	# 	for index, item of table._rowLayers
	# 		console.log index, item

	# 	table.setSelectedRowIndexes("selection", [0])
			
app.views.layerTable.on "change:selection:selection", (info) ->
	app.state.selectedLayerId = info.new[0].data.id if info.new?.length
	table.reload()
	table.render()

app.views.stateTable.on "change:selection:selection", (info) ->
	state = info.new[0].data.name if info.new?.length
	bridge.send("ui:setstate", {id:app.state.selectedLayerId, state:state})








