assert = require "assert"
utils = require "../src/utils.coffee"


describe "Layer sorting", ->

	TEST = [
		{id:4, superLayer:3, index:1},
		{id:1, superLayer:null, index:1},
		{id:2, superLayer:1, index:2},
		{id:3, superLayer:1, index:1},
	]

	it "should get sub layers", ->
	
		assert.deepEqual utils.subLayers(null, TEST), [
			{id:1, superLayer:null, index:1},
		]

		assert.deepEqual utils.subLayers(1, TEST), [
			{id:2, superLayer:1, index:2},
			{id:3, superLayer:1, index:1},
		]

		assert.deepEqual utils.subLayers(2, TEST), []

		assert.deepEqual utils.subLayers(3, TEST), [
			{id:4, superLayer:3, index:1},
		]

	it "should sort layers correctly", ->

		assert.deepEqual utils.sortLayersByHierachy(TEST), [
			{id:1, superLayer:null, index:1, level:0},
			{id:2, superLayer:1, index:2, level:1},
			{id:3, superLayer:1, index:1, level:1},
			{id:4, superLayer:3, index:1, level:2},
		]