
exports.bridge =  (require "./Bridge.coffee").bridge
exports.runtime = (require "./Runtime.coffee").runtime
exports.context = (require "./Context.coffee")

{HighlightComponent} = require "./HighlightComponent.coffee"

# Add simple require function if it's not there 
window.require ?= (module) -> throw Error("Module #{module} can't be found")

getLayerById = (id) ->

	layers = Framer.CurrentContext._layers or Framer.CurrentContext._layerList

	for layer in layers
		return layer if layer.id is id

setupContext = ->

	context = new exports.context.ContextListener(Framer.CurrentContext)

	# Layer selection highlighting
	highlighter = new HighlightComponent()

	exports.bridge.on "ui:highlight", (info) ->
		highlighter.highlight(getLayerById(info.id))

	exports.bridge.on "ui:unhighlight", ->
		highlighter.unhighlight()

	# Layer state selection
	savedProperties = null
	exports.bridge.on "ui:setstate", (info) ->
		layer = getLayerById(info.id)

		if info.state == "Current"
			layer.properties = savedProperties
		else
			savedProperties = layer.properties		
			layer.states.switchInstant(info.state)

	# Layer state property update
	exports.bridge.on "ui:updateState", (info) ->
		layer = getLayerById(info.layerId)
		layer[info.propertyName] = info.value
		layer.states._states[info.stateName][info.propertyName] = info.value

if window?
	window.FramerStudio = exports
	setupContext()
